



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle DBLINK 简单使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle DBLINK 简单使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 20:37:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>oracle在进行跨库访问时，可以通过创建dblink实现，今天就简单的介绍下如果创建dblink，以及通过dblink完成插入、修改、删除等操作</p>
<p>首先了解下环境：在tnsnames.ora中配置两个数据库别名：orcl(用户名：wangyong 密码：1988)、orcl2(用户名：wangyong 密码：123456)，在orcl中 &nbsp; &nbsp; 创建database link来访问orcl2</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128211136816-1400734047.png" /></p>
<p>第一步：赋予权限</p>
<p>在创建database link之前，我们需要判断，登陆的用户是否具备创建database link 的权限，所以我们执行以下的语句(用wangyong用户登陆orcl)：</p>
<div>
<pre class="prettyprint linenums">-- 查看wangyong用户是否具备创建database link 权限<br />
select * from user_sys_privs where privilege like upper('%DATABASE LINK%') AND USERNAME='WANGYONG';</pre>
</div>
<p>如果查询有返回行，则表示具备创建database link权限，否则，则需要使用sys登陆orcl为WANGYONG用户赋予创建权限</p>
<div>
<pre class="prettyprint linenums">-- 给wangyong用户授予创建dblink的权限<br />
grant create public database link to wangyong;</pre>
</div>
<p>此时，再执行上面查看是否具备权限的sql语句，会发现有返回行，表示，WANGYONG这个用户已经具备创建database link的权限</p>
<p>第二步；创建database link</p>
<p>我所了解到的创建方式有两种：1)通过pl/sql developer图形化创建、2)通过sqlplus中的sql语句创建，依次来看</p>
<p>1)pl/sql developer 图形化创建</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128213146237-382522419.png" /></p>
<p>填写完成后点击&ldquo;Apply&rdquo;按钮即可创建成功。</p>
<p>2)sql语句创建</p>
<div>
<pre class="prettyprint linenums">-- 注意一点，如果密码是数字开头，用&ldquo;&rdquo;括起来<br />
create public database link TESTLINK2 connect to WANGYONG identified by "123456" USING 'ORCL21'</pre>
</div>
<p>这样，就完成了简单database简单的创建</p>
<p>第三步：操作</p>
<p>首先，我们需要在ORCL2库中新建一张表，并插入部分数据，如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128214049628-2011686338.png" /></p>
<p>现在，我们通过database link 在orcl中访问这张属于orcl2库中WANGYONG的表COMPANY</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128214349487-1080843563.png" /></p>
<p>从截图中可以看到，在ORCL中可以成功访问到ORCL2中用户WANGYONG的表</p>
<p>下面，利用同样的方式，进行插入，修改，删除操作，依次看截图，每一次操作后均执行查询语句，可对比执行效果：</p>
<p>1)插入</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128214917972-2045571818.png" /></p>
<p>2)修改</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128214928831-704582202.png" /></p>
<p>3)删除</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/75922/201701/75922-20170128214937316-574414353.png" /></p>
<p>至此，简单的dblink操作就可以了，对于上面的链接字符串，还可以创建同义词代替，会稍微省点事</p>
<div>
<pre class="prettyprint linenums">-- 创建同义词<br />create synonym TESTSYNONYM FOR company@TESTLINK1;</pre>
</div>
<p>那么上面的查询、插入、修改、删除中可直接用WYSYNONYM代替company@TESTLINK1即可，例如查询语句可改成如下方式（插入，修改，删除类似）：</p>
<div>
<pre class="prettyprint linenums">-- 查询ORCL2中WANGYONG用户的表COMPANY<br />
SELECT * FROM TESTSYNONYM order by id</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z6j0vq.html">struts2是如何加载相关的package元素节点信息的</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4mk79.html">【HDU 1007】Quoit Design</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq45nzn9.html">1-02 启动和停止Sql Sever的服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g66neq.html">BFS&lpar;双向&rpar; HDOJ 3085 Nightmare Ⅱ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnwd6q.html">datatables使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1n0639.html">context-param引发spring容器以及servlet容器的关联</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz167w8.html">C&num;串口通信程序详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg0djm8.html">如何在 Windows上编译Objective-C</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zgwkk9.html">《NLTK基础教程》译者序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1jkl8.html">Tenka1 Programmer Contest  D - IntegerotS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj7gvr8.html">PYTHON装饰器用法及演变</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllexg1q.html">C&num; 结构与类的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5vwx7q.html">Delphi  SetParent 嵌入其他应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1epmk9.html">20155234 Exp3 免杀原理与实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vr75zq.html">AndroidStudio创建项目时一直处于building&OpenCurlyDoubleQuote;project name&rdquo;gradle project info的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p60n0q.html">LINUX修改、增加IP的方法&comma;一张网卡绑定多个IP&sol;漂移IP【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kv13wq.html">使用结构struct作为Dictionary&amp;lt&semi;TKey&comma;TValue&amp;gt&semi;的键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjnw37q.html">C&plus;&plus;类成员空间分配和虚函数表</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mmykv8.html">bzoj2676 Contra</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x02l39.html">docker运行环境安装-后续步骤（二）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95glky6q.html">关于tcp中time&lowbar;wait状态的4个问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r0xxo9.html">Effective Java 第三版&mdash;&mdash;52&period; 明智而审慎地使用重载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2py5y9.html">spring3-mvc-maven-hello-world-master  mvn jetty&colon;run  及 mvn war&colon;war 指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv6ox28.html">adb命令使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ep0oq.html">【Android】Android布局文件的一些属性值</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m26gmpq.html">STM32 ADC 采样 频率的确定</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j5x45q.html">MAC &sol;usr&sol;local 文件夹权限问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyp51d9.html">Java知多少（51）finally</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gl5pmq.html">关于使用maven打包如何聚合资源文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyne6dq.html">FatTree拓扑结构</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
